<?php
class Sedes extends MY_Controller
{
	
function __construct(){
	parent::__construct();
	$this->load->model('companies_model');
}

function index(){
	redirect('grupos/lista');
	}

function acceso_restringido() {
	$data['content']='acceso_restringido';
	$this->load->view('v_content',$data);
}

function check_access () {
	$this->load->library('sec_validation');	
	$result = $this->sec_validation->login_check_access($this->session->userdata('usuario_id'),$this->router->fetch_class(),$this->router->fetch_method());
	if (!$result) {
	$this->session->set_flashdata('message_error', 'Acceso Restringido=>'.$this->router->fetch_class()."/".$this->router->fetch_method());
	redirect('usuarios/acceso_restringido');
	}
}


function ver($id= null){
	
	// Valida Acceso
	$this->check_access();

	// Sin parametro 
	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_sedes_msg_noexiste'));
		redirect('grupos/lista');		
	  }
  
	$sede = $this->companies_model->get_site($id);
	// No existe
	if (empty($sede)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_sedes_msg_noexiste'));
		redirect('grupos/lista');		
	  }
	$data['sede'] = $sede;
	$data['logs'] = $this->companies_model->get_site_log($id);		
	$data['content']='admin/sedes/ver';
	$this->load->view('v_content',$data);

	}

function editar($id= null,$origen="lista"){
	// Valida Acceso
	$this->check_access();

	// Sin parametro 
	if (is_null($id)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_sedes_msg_noexiste'));
		redirect('grupos/lista');		
	  }

	$sede = $this->companies_model->get_site($id);
	// No existe
	if (empty($sede)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_sedes_msg_noexiste'));
		redirect('grupos/lista');		
	  }
	  
	$this->load->library('form_validation');

   if(isset($_POST["cancelar"])) {
		$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_cancelado'));
		if ($origen=="ver") { redirect('sedes/ver/'.$id);} else {redirect('empresas/ver/'.$this->input->post('empresa'));}
   }
			
	if (!empty($_POST))
	{    
		$this->form_validation->set_rules('nombre', 'lang:eap_sedes_nombre', 'required|trim|max_length[100]|xss_clean|callback_validar_unico['.$id.']');     
	
		$this->form_validation->run();
	}
	
   if($this->form_validation->run()){

		$historial='';

		$data['fecha_modificacion'] = date("Y-m-d H:i:s");
		$data['id_usuario_modificacion'] = $this->session->userdata('usuario_id');
		if($this->input->post('nombre') != $sede['nombre']) {$data['nombre'] = $this->input->post('nombre');$historial.="Nombre@@$sede[nombre]@@$data[nombre]||";}
		
		if ($this->companies_model->set_site($id, $data)){
			// GUARDA LOG
			$data_log = array(
				'id_sedes' => $id,
				'fecha' => date("Y-m-d H:i:s"), 
				'modificador' => $this->session->userdata('usuario_nombre_apellido'),	
				'modificaciones' => $historial);
			$this->companies_model->set_site_log($data_log);			
			$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_guardado'));
			if ($origen=="ver") { redirect('sedes/ver/'.$id);} else {redirect('empresas/ver/'.$this->input->post('empresa'));}
			//echo $this->db->last_query();
		} else {
			$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_guardado_error'));	
		}
   }
	

	$data['origen']= $origen;
	$data['sede'] = $sede;
	$data['logs'] = $this->companies_model->get_site_log($id);	
	$data['content']='admin/sedes/editar';
	$this->load->view('v_content',$data);

	}	

function nuevo($id_empresa){
	// Valida Acceso
	$this->check_access();

	// Sin parametro 
	if (is_null($id_empresa)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_empresas_msg_noexiste'));
		redirect('grupos/lista');		
	  }

	$empresa = $this->companies_model->get_company($id_empresa);
	// No existe
	if (empty($empresa)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_empresas_msg_noexiste'));
		redirect('grupos/lista');		
	  }

	
	$this->load->library('form_validation');

   if(isset($_POST["cancelar"])) {
		$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_cancelado_nuevo'));
		redirect('empresas/ver/'.$id_empresa);
   }
			
	if (!empty($_POST))
	{    
		$this->form_validation->set_rules('nombre', 'lang:eap_sedes_nombre', 'required|trim|max_length[100]|xss_clean|callback_validar_unico');     
		$this->form_validation->run();
	}
	
   if($this->form_validation->run()){
		$historial='';
		$data['fecha_creacion'] = date("Y-m-d H:i:s");
		$data['id_usuario_creacion'] = $this->session->userdata('usuario_id');
		$data['fecha_modificacion'] = date("Y-m-d H:i:s");
		$data['id_usuario_modificacion'] = $this->session->userdata('usuario_id');
		$data['empresa'] = $id_empresa;		
		if($this->input->post('nombre') != "") {$data['nombre'] = $this->input->post('nombre');$historial.="Nombre@@@@$data[nombre]||";}

		$id=$this->companies_model->set_site('', $data,'insert');
		
		if (is_numeric($id)){
			// Guardar LOG de Modificacion
			$data_log = array(
				'id_sedes' => $id,
				'fecha' => date("Y-m-d H:i:s"), 
				'modificador' => $this->session->userdata('usuario_nombre_apellido'),	
				'modificaciones' => $historial);
			$this->companies_model->set_site_log($data_log);
			
			$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_guardado'));
			redirect('sedes/ver/'.$id);
			//echo $this->db->last_query();
		} else {
			$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_guardado_error'));	
		}
   }
	

	$sede = array(
		'nombre'=>'',
		'empresa'=>$id_empresa,
		'empresa_nombre'=>$empresa['nombre'],
		'grupo_nombre'=>$empresa['grupo_nombre']);

	$data['sede'] = $sede;
	$data['content']='admin/sedes/nuevo';
	$this->load->view('v_content',$data);
	
	}	

	
function cambiar_estado($id=null,$estado=null,$origen=null) {
	// Valida Acceso
	$this->check_access();
	
	if (is_null($id) or is_null($estado)) {
		$this->session->set_flashdata('message_error', $this->lang->line('eap_sedes_msg_guardado_estado_error'));
		redirect('grupos/lista');	
	}

	switch ($estado) {
		case "activar":
			$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_activado'));
			if (!$this->companies_model->set_status_site($id,true)) { $this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_guardado_estado_error')); }
			redirect('empresas/ver/'.$origen);	
			break;
		case "desactivar":
			$this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_desactivado'));
			if (!$this->companies_model->set_status_site($id,false)) { $this->session->set_flashdata('message', $this->lang->line('eap_sedes_msg_guardado_estado_error')); }
			redirect('empresas/ver/'.$origen);	
			break;
		default:
			$this->session->set_flashdata('message_error', $this->lang->line('eap_sedes_msg_guardado_estado_error'));
			redirect('empresas/ver/'.$origen);	
	}
}		

function validar_unico ($nombre=null,$id=null){
   $empresa = $this->input->post('empresa');
   if ($this->companies_model->is_unique_site($nombre,$id,$empresa)) {
	   return TRUE;
   } else {
	   $this->form_validation->set_message('validar_unico', $this->lang->line('eap_sedes_msg_validar_unico').'==>'.$nombre.' Empresa=>'.$empresa);
	   return FALSE;
   }
}
	
}


